// 'ThemeFlood' is the global object for ThemeFlood theme functions
var ThemeFlood = {};
// Reduce potential conflicts with other scripts on the page
ThemeFlood.jQuery = jQuery.noConflict(true);
var $ThemeFlood = ThemeFlood.jQuery;
// Create a unique object and namespace for theme functions
ThemeFlood.themeFunctions = {};
// Define a closure
ThemeFlood.themeFunctions = (function() {
  // When jQuery is used it will be available as $ and jQuery but only inside the closure
  var jQuery = ThemeFlood.jQuery;
  var $ = jQuery;
	var $ThemeFlood = jQuery.noConflict();

  $ThemeFlood(document).ready(function () {
    // ExtraContent functionality
  	var extraContent =  (function() {
  		var ecValue = 20;
  		for (i=1;i<=ecValue;i++)
  		{
  			$ThemeFlood('#myExtraContent'+i+' script').remove();
  			$ThemeFlood('#myExtraContent'+i).appendTo('#extraContainer'+i);
  		}
  	})();

    // FreeStyle banners
  	$ThemeFlood('#fs').appendTo('#freeStyle');
  	$ThemeFlood("img[src$='banner.jpg'], img[src$='Banner.jpg'], img[src$='header.jpg'], img[src$='Header.jpg'], img[src$='freestyle.jpg'], img[src$='Freestyle.jpg'], img[src$='freestyle.jpg'], img[src$='FreeStyle.jpg']").appendTo('#freeStyle');

    // RapidWeaver 7 banners
  	if ($ThemeFlood("#rwBanner img").attr('data-rwbanner') === '%banner_path%') {
  	    // If the data attribute is equal to %banner_path%, assume the theme is being used in RW6 or less, so do nothing
  	    $("#rwBanner img").remove();
  	} else {
  		// Otherwise assume the theme is being used in RW7+ so replace the blank image with the banner image from the data attribute
  		$ThemeFlood("#rwBanner img").attr("src",$("#rwBanner img").attr("data-rwbanner"));
  	}

    // Function to apply unique class ID's onto each list, list item and suppress parent pages
  	$ThemeFlood("#nav li").each(function (i) {
  		i = i+1;
  		$ThemeFlood(this).addClass("link"+i);
  		});
  		$ThemeFlood("#nav ul").each(function (i) {
     		i = i+1;
     		$ThemeFlood(this).addClass("list"+i);
  	});

    // Links with a class of 'newtab' open in new tabs or windows
  	$ThemeFlood('a.newtab').append("<span class='newWindowIcon'> <i class='fas fa-external-link-alt'></i></span>");
  	$ThemeFlood('a.newtab').click( function() {
  		window.open( $(this).attr('href') );
  		return false;
  	});

    // Smooth-scroll the 'back to top' link
    $ThemeFlood('#backToTop, .backtotop').click(function() {
        if (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'')
            || location.hostname == this.hostname) {
            var target = $(this.hash);
            target = target.length ? target : $ThemeFlood('[name=' + this.hash.slice(1) +']');
               if (target.length) {
                 $ThemeFlood('html,body').animate({
                     scrollTop: target.offset().top
                }, 1000);
                return false;
            }
        }
    });

    // Clone the main navigation into different parts of the page
  	var $clonednav = $ThemeFlood('#RaftNav > ul').clone();
  	$ThemeFlood('#blockNav, #footerNav').html($clonednav);

  	$ThemeFlood("#RaftNav li a").each(function() {
  		if ($(this).next().length > 0) {
  			$(this).addClass("parent");
  		};
  	});

  	var raftparent = $('#RaftNav li a.parent');
  	$ThemeFlood( '<div class="more"><i class="fas fa-angle-down"></i>' ).insertBefore(raftparent);
  	$ThemeFlood('.more').click(function(){
  		$(this).parent('li').toggleClass('open');
  	});
  	$ThemeFlood('#RaftNavButton').click(function(){
  		$('#RaftNavButton, #RaftNav').toggleClass('menu-open');
  	});

    // If a touch device is detected, add 'touchDevice' class to the page
  	if( /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent) ) {
  		$ThemeFlood('body').addClass('RaftTouchDevice');
  	}

    // Function to fade in the back-to-top button on page scroll
    $ThemeFlood(window).scroll(function () {
        if ($ThemeFlood(this).scrollTop() > 500) {
            $ThemeFlood('#backToTopWrapper').fadeIn();
        } else {
            $ThemeFlood('#backToTopWrapper').fadeOut();
        }
    });

  });

})(ThemeFlood.themeFunctions);
